
/* local6.com scripts */
// Begin national js scripts


var head=document.getElementsByTagName('head');
if (head) head=head[0];

/* private function only called in this context to add a <meta> tag to <head> */
function addMeta(name, content) {
    if (head) {
        var meta=document.createElement('meta');
        meta.setAttribute('name',name);
        meta.setAttribute('content',content);
        head.appendChild(meta);
    }
}

/* public function called from WebTrends code to scan the page for custom <span> tags and add the info to <head> as <meta> tags.*/
function ib_WTCustomTags() {
    var spans=document.getElementsByTagName('span');
    if (spans && spans.length > 0) {
        for (var i=0; i<spans.length;i++) {
            var span=spans[i];
            if (span) {
                var tag=span.getAttribute('WT_tag');
                if (tag) {
                    var val=span.getAttribute(tag);
                    if (val) {
                        addMeta(tag,val);
                    }
                }
            }
        }
    }
}

function ib_WTFlashEvent() {
	dcsMultiTrack(arguments);
	// ad refresh portion goes here
}

/* custom function for video players to call when a video is played from an embedded player */
function ib_WTPlayEvent() {
	var url = window.location;
	if (url == null || url == '') return; // not likely to be happening ;-)

	var parsed_url = String(url).split('/'); // [0]='http:', [1]='', [2]='www.wnbc.com', ...
	var video = parsed_url[3]; // check if this one is video (indicates main player page)
	if (video.toLowerCase() != 'video')
		dcsMultiTrack(arguments);
}

/* custom function for SigAlert tracking to set parameters based on url */
function ib_WTSigAlert(url) {
	// Topic=Traffic
	// Section=maps,traveltimes,incidents, etc.
	// MediaType=SigAlert
	
	if (url == null || url == '') return;

	// parse the url to figure out the topic and section for SigAlert pages (example: http://www.sigalert.com/traveltimes.asp?Region=Bay+Area&partner=ktvu)
	var parsed_url = String(url).split('/'); // [0]='http:', [1]='', [2]='www.sigalert.com', ...
	var section = parsed_url[3]; // parse this one out to get just the name of the asp file minus the '.asp'
	section = String(section).split('.'); // this should give [0]=traveltimes without the .asp extension
	WT.cg_n = 'Traffic';
	WT.cg_s = section[0];
	DCSext.mtype = 'SigAlert';
}



/* *********************************************************************
  Copyright 2007, Internet Broadcasting Systems. All Rights Reserved.
  $Id: webtrends.js,v 1.5 2007/05/24 19:05:05 mwakefield Exp $
  $Source: /u01/cvsroot/javascript/webtrends/webtrends.js,v $
  Phaedra Content ID: 5097349
********************************************************************* */

using('IBSYS.tracking');

IBSYS.tracking.flashVersion = function() {
	var nav = navigator,
		UNDEF = 'undefined',
		SHOCKWAVE_FLASH = "Shockwave Flash",
		SHOCKWAVE_FLASH_AX = "ShockwaveFlash.ShockwaveFlash";
	
	var playerVersion = [0,0,0],
		d = null;
	if (typeof nav.plugins != UNDEF && typeof nav.plugins['Shockwave Flash'] == 'object') {
		d = nav.plugins[SHOCKWAVE_FLASH].description;
		if (d) {
			d = d.replace(/^.*\s+(\S+\s+\S+$)/, "$1");
			playerVersion[0] = parseInt(d.replace(/^(.*)\..*$/, "$1"), 10);
			playerVersion[1] = parseInt(d.replace(/^.*\.(.*)\s.*$/, "$1"), 10);
			playerVersion[2] = /r/.test(d) ? parseInt(d.replace(/^.*r(.*)$/, "$1"), 10) : 0;
		}
	}	else if (typeof window.ActiveXObject != UNDEF) {
		var a = null, fp6Crash = false;
		try {
			a = new ActiveXObject(SHOCKWAVE_FLASH_AX + ".7");
		}
		catch(e) {
			try { 
				a = new ActiveXObject(SHOCKWAVE_FLASH_AX + ".6");
				playerVersion = [6,0,21];
				a.AllowScriptAccess = "always";  // Introduced in fp6.0.47
			}
			catch(e) {
				if (playerVersion[0] == 6) {
					fp6Crash = true;
				}
			}
			if (!fp6Crash) {
				try {
					a = new ActiveXObject(SHOCKWAVE_FLASH_AX);
				}
				catch(e) {}
			}
		}
		if (!fp6Crash && a) { // a will return null when ActiveX is disabled
			try {
				d = a.GetVariable("$version");  // Will crash fp6.0.21/23/29
				if (d) {
					d = d.split(" ")[1].split(",");
					playerVersion = [parseInt(d[0], 10), parseInt(d[1], 10), parseInt(d[2], 10)];
				}
			}
			catch(e) {}
		}
	}
	return playerVersion;
}();

using('IBSYS.WebTrends');

var gService = true;
var gTimeZone = -5;

IBSYS.WebTrends.collectUserData = function() {
  using('IBSYS.SiteLife');	
  if (IBSYS.SiteLife.userData && IBSYS.SiteLife.userData.DisplayName != 'anonymous') {
    DCSext['ib_sl_key'] = IBSYS.SiteLife.userData.UserKey.Key;
    DCSext['ib_gender'] = IBSYS.SiteLife.userData.Sex;
    DCSext['ib_age'] = IBSYS.SiteLife.userData.Age;
	}
}

// Code section for Enable First-Party Cookie Tracking
function dcsCookie(){
	if (typeof(dcsOther)=="function"){
		dcsOther();
	}
	else if (typeof(dcsPlugin)=="function"){
		dcsPlugin();
	}
	else if (typeof(dcsFPC)=="function"){
		dcsFPC(gTimeZone);
	}
}
function dcsGetCookie(name){
	var pos=document.cookie.indexOf(name+"=");
	if (pos!=-1){
		var start=pos+name.length+1;
		var end=document.cookie.indexOf(";",start);
		if (end==-1){
			end=document.cookie.length;
		}
		return unescape(document.cookie.substring(start,end));
	}
	return null;
}
function dcsGetCrumb(name,crumb){
	var aCookie=dcsGetCookie(name).split(":");
	for (var i=0;i<aCookie.length;i++){
		var aCrumb=aCookie[i].split("=");
		if (crumb==aCrumb[0]){
			return aCrumb[1];
		}
	}
	return null;
}
function dcsGetIdCrumb(name,crumb){
	var cookie=dcsGetCookie(name);
	var id=cookie.substring(0,cookie.indexOf(":lv="));
	var aCrumb=id.split("=");
	for (var i=0;i<aCrumb.length;i++){
		if (crumb==aCrumb[0]){
			return aCrumb[1];
		}
	}
	return null;
}
// replaced with new function from WebTrends 4-6-2006
function dcsFPC_OLD(offset){
	if (typeof(offset)=="undefined"){
		return;
	}
	var name=gFpc;
	var dCur=new Date();
	dCur.setTime(dCur.getTime()+(dCur.getTimezoneOffset()*60000)+(offset*3600000));
	var dExp=new Date(dCur.getTime()+315360000000);
	var dSes=new Date(dCur.getTime());
	if (document.cookie.indexOf(name+"=")!=-1){
		var id=dcsGetIdCrumb(name,"id");
		var lv=parseInt(dcsGetCrumb(name,"lv"));
		var ss=parseInt(dcsGetCrumb(name,"ss"));
		if ((id==null)||(id=="null")||isNaN(lv)||isNaN(ss)){
			return;
		}
		WT.co_f=id;
		var dLst=new Date(lv);
		dSes.setTime(ss);
		if ((dCur.getTime()>(dLst.getTime()+1800000))||(dCur.getTime()>(dSes.getTime()+28800000))){
			dSes.setTime(dCur.getTime());
			WT.vt_f_s="1";
		}
		if ((dCur.getDay()!=dLst.getDay())||(dCur.getMonth()!=dLst.getMonth())||
			(dCur.getYear()!=dLst.getYear())){
			WT.vt_f_d="1";
		}
	}
	else{
		var tmpname=name+"_TMP=";
		document.cookie=tmpname+"1";
		if (document.cookie.indexOf(tmpname)!=-1){
			document.cookie=tmpname+"; expires=Thu, 01-Jan-1970 00:00:01 GMT";
			if ((typeof(gWtId)!="undefined")&&(gWtId!="")){
				WT.co_f=gWtId;
			}
			else if ((typeof(gTempWtId)!="undefined")&&(gTempWtId!="")){
				WT.co_f=gTempWtId;
				WT.vt_f="1";
			}
			else{
				WT.co_f="2";
				var cur=dCur.getTime().toString();
				for (var i=2;i<=(32-cur.length);i++){
					WT.co_f+=Math.floor(Math.random()*16.0).toString(16);
				}
				WT.co_f+=cur;
				WT.vt_f="1";
			}
			if (typeof(gWtAccountRollup)=="undefined"){
				WT.vt_f_a="1";
			}
			WT.vt_f_s="1";
			WT.vt_f_d="1";
		}
		else{
			WT.vt_f="2";
			WT.vt_f_a="2";
			return;
		}
	}
	WT.co_f=escape(WT.co_f);
	WT.vt_sid=WT.co_f+"."+dSes.getTime();
	var expiry="; expires="+dExp.toGMTString();
	document.cookie=name+"="+"id="+WT.co_f+":lv="+dCur.getTime().toString()+":ss="+
		dSes.getTime().toString()+expiry+"; path=/"+(((typeof(gFpcDom)!="undefined")&&
		(gFpcDom!=""))?("; domain="+gFpcDom):(""));
}

function dcsFPC(offset){
	if (typeof(offset)=="undefined"){
		return;
	}
	if (document.cookie.indexOf("WTLOPTOUT=")!=-1){
		return;
	}
	var name=gFpc;
	var dCur=new Date();
	var adj=(dCur.getTimezoneOffset()*60000)+(offset*3600000);
	dCur.setTime(dCur.getTime()+adj);
	var dExp=new Date(dCur.getTime()+315360000000);
	var dSes=new Date(dCur.getTime());
	WT.co_f=WT.co_f_i=WT.vt_sid=WT.vt_f=WT.vt_f_a=WT.vt_f_s=WT.vt_f_d=WT.vt_f_tlh=WT.vt_f_tlv="";
	if (document.cookie.indexOf(name+"=")==-1){
		if ((typeof(gWtId)!="undefined")&&(gWtId!="")){
			WT.co_f=gWtId;
		}
		else if ((typeof(gTempWtId)!="undefined")&&(gTempWtId!="")){
			WT.co_f=gTempWtId;
			WT.vt_f="1";
		}
		else{
			WT.co_f="2";
			var cur=dCur.getTime().toString();
			for (var i=2;i<=(32-cur.length);i++){
				WT.co_f+=Math.floor(Math.random()*16.0).toString(16);
			}
			WT.co_f+=cur;
			WT.vt_f="1";
		}
		if (typeof(gWtAccountRollup)=="undefined"){
			WT.vt_f_a="1";
		}
		WT.vt_f_s=WT.vt_f_d="1";
		WT.vt_f_tlh=WT.vt_f_tlv="0";
	}
	else{
		var id=dcsGetIdCrumb(name,"id");
		var lv=parseInt(dcsGetCrumb(name,"lv"));
		var ss=parseInt(dcsGetCrumb(name,"ss"));
		if ((id==null)||(id=="null")||isNaN(lv)||isNaN(ss)){
			return;
		}
		WT.co_f=id;
		var dLst=new Date(lv);
		WT.vt_f_tlh=Math.floor((dLst.getTime()-adj)/1000);
		dSes.setTime(ss);
		if ((dCur.getTime()>(dLst.getTime()+1800000))||(dCur.getTime()>(dSes.getTime()+28800000))){
			WT.vt_f_tlv=Math.floor((dSes.getTime()-adj)/1000);
			dSes.setTime(dCur.getTime());
			WT.vt_f_s="1";
		}
		if ((dCur.getDay()!=dLst.getDay())||(dCur.getMonth()!=dLst.getMonth())||
			(dCur.getYear()!=dLst.getYear())){
			WT.vt_f_d="1";
		}
	}
	WT.co_f=escape(WT.co_f);
	WT.co_f_i=WT.co_f+"-"+gDcsId.substring(gDcsId.indexOf("_")+1,gDcsId.length);
	WT.vt_sid=WT.co_f+"."+(dSes.getTime()-adj);
	var expiry="; expires="+dExp.toGMTString();
	document.cookie=name+"="+"id="+WT.co_f+":lv="+dCur.getTime().toString()+
		":ss="+dSes.getTime().toString()+expiry+"; path=/"+
		(((typeof(gFpcDom)!="undefined")&&(gFpcDom!=""))?("; domain="+gFpcDom):(""));
	if (document.cookie.indexOf(name+"=")==-1){
		WT.co_f=WT.co_f_i=WT.vt_sid=WT.vt_f_s=WT.vt_f_d=WT.vt_f_tlh=WT.vt_f_tlv="";
		WT.vt_f=WT.vt_f_a="2";
	}
}

// Code section for Use the new first-party cookie generated with this tag.
var gFpc="WT_FPC";
var gWtId="";
var gTempWtId="";
var gConvert=true;

function dcsAdv(){
	dcsFunc("dcsET");
	dcsFunc("dcsCookie");
	dcsFunc("dcsAdSearch");
}

function dcsVar(){
	var dCurrent=new Date();
	WT.tz=dCurrent.getTimezoneOffset()/60*-1;
	if (WT.tz==0){
		WT.tz="0";
	}
	WT.bh=dCurrent.getHours();
	WT.ul=navigator.appName=="Netscape"?navigator.language:navigator.userLanguage;
	if (typeof(screen)=="object"){
		WT.cd=navigator.appName=="Netscape"?screen.pixelDepth:screen.colorDepth;
		WT.sr=screen.width+"x"+screen.height;
	}
	if (typeof(navigator.javaEnabled())=="boolean"){
		WT.jo=navigator.javaEnabled()?"Yes":"No";
	}
	if (document.title){
		WT.ti=document.title;
	}
	WT.js="Yes";
	if (typeof(gVersion)!="undefined"){
		WT.jv=gVersion;
	}
	if (document.body&&document.body.addBehavior){
		document.body.addBehavior("#default#clientCaps");
		if (document.body.connectionType){
			WT.ct=document.body.connectionType;
		}
		document.body.addBehavior("#default#homePage");
		WT.hp=document.body.isHomePage(location.href)?"1":"0";
	}
	if (parseInt(navigator.appVersion)>3){
		if ((navigator.appName=="Microsoft Internet Explorer")&&document.body){
			WT.bs=document.body.offsetWidth+"x"+document.body.offsetHeight;
		}
		else if (navigator.appName=="Netscape"){
			WT.bs=window.innerWidth+"x"+window.innerHeight;
		}
	}
	WT.fi="No";
//	if (window.ActiveXObject){
//		if ((typeof(gFV)!="undefined")&&(gFV.length>0)){
//			WT.fi="Yes";
//			WT.fv=gFV;
//		}
//	}
//	else if (navigator.plugins&&navigator.plugins.length){
//		for (var i=0;i<navigator.plugins.length;i++){
//			if (navigator.plugins[i].name.indexOf('Shockwave Flash')!=-1){
//				WT.fi="Yes";
//				WT.fv=navigator.plugins[i].description.split(" ")[2];
//				break;
//			}
//		}
//	}
	if (IBSYS.tracking.flashVersion instanceof Array) {
		WT.fi='Yes';
		WT.fv=IBSYS.tracking.flashVersion.join('.');
	}
	WT.sp="@@SPLITVALUE@@";
	DCS.dcsdat=dCurrent.getTime();
	DCS.dcssip=window.location.hostname;
	DCS.dcsuri=window.location.pathname;
	if (window.location.search){
		DCS.dcsqry=escape(window.location.search);
		if (gQP.length>0){
			for (var i=0;i<gQP.length;i++){
				var pos=DCS.dcsqry.indexOf(gQP[i]);
				if (pos!=-1){
					var front=DCS.dcsqry.substring(0,pos);
					var end=DCS.dcsqry.substring(pos+gQP[i].length,DCS.dcsqry.length);
					DCS.dcsqry=front+end;
				}
			}
		}
	}
	if ((window.document.referrer!="")&&(window.document.referrer!="-")){
		if (!(navigator.appName=="Microsoft Internet Explorer"&&parseInt(navigator.appVersion)<4)){
			DCS.dcsref=window.document.referrer;
		}
	}
}

function A(N,V){
	return "&"+N+"="+dcsEscape(V);
}

function dcsEscape(S){
	if (typeof(RE)!="undefined"){
		var retStr = new String(S);
		for (R in RE){
			retStr = retStr.replace(RE[R],R);
		}
		return retStr;
	}
	else{
		return escape(S);
	}
}

function dcsLoadHref(evt){
	if ((typeof(gHref)!="undefined")&&(gHref.length>0)){
		window.location=gHref;
		gHref="";
	}
}

function dcsCreateImage(dcsSrc){
	if (document.images){
		gImages[gIndex]=new Image;
		if ((typeof(gHref)!="undefined")&&(gHref.length>0)){
			gImages[gIndex].onload=gImages[gIndex].onerror=dcsLoadHref;
		}
		gImages[gIndex].src=dcsSrc;
		gIndex++;
	}
	else{
		document.write('<IMG BORDER="0" NAME="DCSIMG" WIDTH="1" HEIGHT="1" SRC="'+dcsSrc+'">');
	}
}

function dcsMeta(){
	var elems;
	if (document.all){
		elems=document.all.tags("meta");
	}
	else if (document.documentElement){
		elems=document.getElementsByTagName("meta");
	}
	if (typeof(elems)!="undefined"){
		for (var i=1;i<=elems.length;i++){
			var meta=elems.item(i-1);
			if (meta.name){
				if (meta.name.indexOf('WT.')==0){
					WT[meta.name.substring(3)]=meta.content;
				}
				else if (meta.name.indexOf('DCSext.')==0){
					DCSext[meta.name.substring(7)]=meta.content;
				}
				else if (meta.name.indexOf('DCS.')==0){
					DCS[meta.name.substring(4)]=meta.content;
				}
			}
		}
	}
}

function dcsTag(){
	var P="http"+(window.location.protocol.indexOf('https:')==0?'s':'')+"://"+
		gDomain+(gDcsId==""?'':'/'+gDcsId)+"/dcs.gif?";
	if (arguments && arguments.length > 0) {
		// overwrite the url to use the passed dcsid
		P="http"+(window.location.protocol.indexOf('https:')==0?'s':'')+"://"+
			gDomain+(arguments[0]==""?'':'/'+arguments[0])+"/dcs.gif?";
	}
	// append something to section if topic = section
	if (WT.cg_n && WT.cg_s && (WT.cg_n.toLowerCase() == WT.cg_s.toLowerCase())) {
		WT.cg_s += "-Main";
	}
	for (N in DCS){
		if (DCS[N]) {
			P+=A(N,DCS[N]);
		}
	}
	for (N in WT){
		if (WT[N]) {
			P+=A("WT."+N,WT[N]);
		}
	}
	for (N in DCSext){
		if (DCSext[N]) {
			P+=A(N,DCSext[N]);
		}
	}
	if (P.length>2048&&navigator.userAgent.indexOf('MSIE')>=0){
		P=P.substring(0,2040)+"&WT.tu=1";
	}

	// don't send a page hit for video index page when loaded thru a direct link to a video 
	// (i.e. coid in the url)
	if (DCSext.mtype && DCSext.mtype.toLowerCase() == 'index' && 
		WT.cg_s.toLowerCase() == 'video' && DCS.dcsuri != '/video/index.html') {
		//dcsCreateImage(P);
	// don't send a page hit for slideshows detail page when loaded 
	// thru a direct link to a slideshow (i.e. coid in the url)
	} else if (WT.cg_s && WT.cg_s.toLowerCase() == 'slideshow' && 
		WT.ti && WT.ti.toLowerCase() == 'slideshow'){
		//dcsCreateImage(P);
	// don't send a page hit for flash slideshow index page 
	// when loaded thru a link to /slideshow/
	} else if (WT.cg_s && WT.cg_s.toLowerCase() == 'slideshow' && 
		DCS.dcsuri && DCS.dcsuri.indexOf('/slideshow/') != -1 && 
		DCSext.content && DCSext.content != ''){
		//dcsCreateImage(P);
	} else {
		dcsCreateImage(P);
	}
}

function dcsFunc(func){
	if (typeof(window[func])=="function"){
		window[func]();
	}
}

function dcsMultiTrack(){
	var dcsid_override = '';
	if (arguments && arguments.length==1) {
		arguments = arguments[0]; // sometimes, an array of arguments is passed as a single argument
	}

	for (var i=0;i<arguments.length;i++){
		if (arguments[i].indexOf('WT.')==0){
			WT[arguments[i].substring(3)]=arguments[i+1];
			i++;
		}
		else if (arguments[i].indexOf('DCS.')==0){
			DCS[arguments[i].substring(4)]=arguments[i+1];
			i++;
		}
		else if (arguments[i].indexOf('DCSext.')==0){
			DCSext[arguments[i].substring(7)]=arguments[i+1];
			i++;
		}
		else if (arguments[i].indexOf('dcsid')==0) {
			dcsid_override=arguments[i+1];
			i++;
		}
	}
	var dCurrent=new Date();
	DCS.dcsdat=dCurrent.getTime();
	if (dcsid_override.length > 0) {
		dcsTag(dcsid_override);
	} else {
		dcsTag();
	}
	//dcsTag();
}


// End national_js scripts

